<?php

/*****************************************************************************\
		(SUPER)ADMIN OVERVIEW
\*****************************************************************************/


function wls_get_pagenow( $page = '' ) {
	global $pagenow;
	$result = $pagenow;
	if( empty( $page ) ) {
		$result.= '?page='.$_GET['page'];
	} else {
		$result.= '?page='.$page;
	}
	return $result;
}



function wls_superadmin_overview_page() {

	wls_flush_last_log();
	
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'view':
    	wls_superadmin_overview_page_view( $_REQUEST['id'] );
    	break;
    case 'clear':
    	$log = wls_get_log( $_GET['id'] );
    	wls_clear( $log->log_name );
    	wls_superadmin_overview_page_default();
    	break;
    case 'register':
    	wls_register( $_POST['logname'], $_POST['description'] );
    	wls_superadmin_overview_page_default();
    	break;
    case 'unregister':
    	$log = wls_get_log( $_GET['id'] );
    	wls_unregister( $log->log_name );
    	wls_superadmin_overview_page_default();
    	break;
    case 'mark-seen':
    	$entries = explode( ',', $_POST['entries'] );
    	foreach( $entries as $entry_id ) {
    		wls_mark_seen( $entry_id );
    	}
		wls_superadmin_overview_page_default(); 
		break;
    default:
    	wls_superadmin_overview_page_default();
    	break;
    }
   
}


function wls_superadmin_overview_page_default() {
	$logs = wls_get_logs();
	$logs_by_id = array();
	$settings = wls_get_settings();
	?>
	<div class="wrap">
		<h2><?php _e( 'WLS system logs', WLS_TEXTDOMAIN ); ?></h2>
		<p><?php _e( 'Select log category:', WLS_TEXTDOMAIN ); ?><!-- Kliknutím na položku zobrazíte záznamy daného logu. V současnosti jsou k dispozici následující: --></p>

		<ul>
			<?php
				foreach( $logs as $log ) {
					$logs_by_id[$log->id] = $log;
					?>
					<li>
						<strong><a href="<?php echo wls_get_pagenow(); ?>&action=view&id=<?php echo $log->id; ?>">
							<?php echo $log->log_name; ?></a></strong>
						&nbsp;-&nbsp;<?php echo esc_attr( $log->description ); ?>&nbsp;
						<a href="<?php echo wls_get_pagenow(); ?>&action=clear&id=<?php echo $log->id; ?>">&curren;</a>&nbsp;
						<a href="<?php echo wls_get_pagenow(); ?>&action=unregister&id=<?php echo $log->id; ?>">&times;</a>
					</li>
					<?php
				}
			?>
		</ul>

		<form method="post">
			<input type="hidden" name="action" value="register" />
			<p>
				<label for="logname"><?php _e( 'Register new log category:', WLS_TEXTDOMAIN ); ?></label>&nbsp;<input type="text" name="logname" />&nbsp;<input type="text" cols="40" name="description" />&nbsp;<input type="submit" value="<?php _e( 'Register', WLS_TEXTDOMAIN ); ?>" />
			</p>
		</form>
		<?php
		
			// TODO prepinani unseen/all
			// TODO filtrovani logu (switch on/off)
			
			// severity filter
			if( isset( $_POST['switch_severity'] ) ) {
				$sev_str = explode( ' ', $_POST['switch_severity'] );
				$min_severity = wls_string_to_severity( $sev_str[0] );
			} else {
				$min_severity = $settings['def_severity_filter'];
			}
			
			// unseen counts
			$unseen = array();
			for( $i=0; $i<=6; ++$i ) {
				$unseen[$i] = wls_get_unseen_entry_count( $i );
			}
			
			//print_r( $unseen );
			
			if( $unseen[$min_severity] > 0 ) {
				?>
				<h3><?php _e( 'New entries', WLS_TEXTDOMAIN ); ?></h3>
				<p><?php 
					printf( __( 'You have currently %d new log entries of severity %s or more.', WLS_TEXTDOMAIN ), 
						$unseen[$min_severity], '<code>'.wls_severity_to_string( $min_severity ).'</code>'
					); 
					if( $unseen[$min_severity] > 100 ) {
						echo ' ';
						_e( 'Showing oldest 100.', WLS_TEXTDOMAIN );
					}
				?></p>
				<?php
			}
			

			?>
			<form method="post">
				<input type="hidden" name="action" value="default" />
				<label><?php _e( 'Severity filter: ', WLS_TEXTDOMAIN ); ?>&nbsp;</label>
				<?php
					for( $i=0; $i<=5; ++$i ) {
						$severity = wls_severity_to_string( $i );
						if( $unseen[$i] > 0 ) {
							$severity.= ' ('.$unseen[$i].')';
						}
						$style = wls_category_to_style( $i );
						if( $i == $min_severity ) {
							$style.= 'border-width: medium; border-color: black; ';
						}
						?>
						<input type="submit" name="switch_severity" value="<?php echo $severity ?>" style="<?php echo $style; ?>" />
						<?php
					}
				?>
			</form>
			<br />
			<?php
			
			
			$mark_form = ( get_current_user_id() == $settings['wls_manager_id'] );
			wls_show_entry_table( 'all', false, 0, 100, $mark_form, 'ASC', $min_severity );
		?>
	</div>
	<?php
}



function wls_show_entry_table( $log_id = 'all', $seen = true, $from = 0, $to = 100, 
	$mark_form = false, $order = 'DESC', $min_severity = 0 ) {

	$entries = wls_get_entries( $log_id, $from, $to, $seen, $order, $min_severity );
	
	?>
	
	<table class="widefat" cellspacing="0">
		<thead>
			<tr>
			    <th scope="col" class="manage-column">id<br />
			    	<?php _e( 'Seen', WLS_TEXTDOMAIN ); ?>
			    </th>
			    <?php
			    	if( $log_id == 'all' ) {
			    		?>
			    		<th scope="col" class="manage-column"><?php _e( 'Log category', WLS_TEXTDOMAIN ); ?></th>
			    		<?php
			    	}
			    ?>
			    <th scope="col" class="manage-column"><?php _e( 'Time', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Blog', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'User', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Severity', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Message', WLS_TEXTDOMAIN ); ?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
			    <th scope="col" class="manage-column">id<br />
			    	<?php _e( 'Seen', WLS_TEXTDOMAIN ); ?>
			    </th>
				<?php
			    	if( $log_id == 'all' ) {
			    		?>
			    		<th scope="col" class="manage-column"><?php _e( 'Log category', WLS_TEXTDOMAIN ); ?></th>
			    		<?php
			    	}
			    ?>
			    <th scope="col" class="manage-column"><?php _e( 'Time', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Blog', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'User', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Severity', WLS_TEXTDOMAIN ); ?></th>
			    <th scope="col" class="manage-column"><?php _e( 'Message', WLS_TEXTDOMAIN ); ?></th>						
			</tr>
		</tfoot>
		<?php
			foreach( $entries as $entry ) {
				$style = wls_category_to_style( $entry->category );
				$seen_entries[] = $entry->id;
				?>
				<tr style="<?php echo $style; ?>">
					<td style="<?php echo $style; ?>">
						<code><small><?php echo $entry->id; ?></small></code><br/>
						<code><small><?php if( $entry->seen ) echo "true"; else echo "false"; ?></small></code>
					</td>
					<?php
						if( $log_id == 'all' ) {
							?>
							<td style="<?php echo $style; ?>"><?php echo $logs_by_id[$entry->log_id]->log_name; ?></td>
							<?php
						}
			    	?>
					<td style="<?php echo $style; ?>"><?php echo $entry->date; ?></td>
					<td style="<?php echo $style; ?>">
						<?php
							if( is_multisite() ) {
								switch_to_blog( $entry->blog_id );
								$blog_name = get_bloginfo( 'name' );
								$blog_url = home_url();
								restore_current_blog(); 
							} else {
								$blog_name = get_bloginfo( 'name' );
								$blog_url = home_url();
							}
							echo '<a href="'.$blog_url.'" style="'.$style.'">'.$blog_name.'</a>'; 
						?>
					</td>
					<td style="<?php echo $style; ?>">
						<?php
							if( $entry->user_id == 0 ) {
								$username = '-';
							} else {
								$userdata = get_userdata( $entry->user_id );
								$username = $userdata->user_login;
							}
							echo $username;
						?>
					</td>
					<td style="<?php echo $style; ?>"><?php echo wls_severity_to_string( $entry->category ); ?></td>
					<td style="<?php echo $style; ?>">
						<?php 
							$text = esc_attr( $entry->text );
							if( strlen( $text ) > 300 ) {
								echo '<small>'.$text.'</small>';
							} else {
								echo $text;
							}
						?>
					</td>
				</tr>
				<?php
			}
		?>
	</table>
	<?php
		if( $mark_form ) {
			?>
			<form method="post">
				<input type="hidden" name="action" value="mark-seen" />
				<input type="hidden" name="entries" value="<?php echo implode( ',', $seen_entries ); ?>" />
				<?php
					if( isset( $_POST['switch_severity'] ) ) {
						?>
						<input type="hidden" name="switch_severity" value="<?php echo $_POST['switch_severity']; ?>" />
						<?php
					}
				?>
				<p class="submit">
					<input type="submit" value="<?php _e( 'Mark as read', WLS_TEXTDOMAIN ); ?>" />    
				</p> 
			</form>
			<?php
		}
		?>
	<?php	
}

/*
<?php _e( , WLS_TEXTDOMAIN ); ?>
__( , WLS_TEXTDOMAIN );
*/

function wls_superadmin_overview_page_view( $log_id ) {

	$entries_per_page = 100;
	if( isset( $_GET['p'] ) ) {
		$page = $_GET['p'];
	} else {
		$page = 1;
	}
	$from = $entries_per_page * ( $page-1 );
	$to = $entries_per_page * $page;
	
	$log = wls_get_log( $log_id );
	
	$entry_count = wls_get_entry_count( $log_id );
	//$entries = wls_get_entries( $log_id, $from, $to );
	
	$navigation = '';
	if( $page > 1 ) {
		$navigation.= '&laquo; <a href="'.wls_get_pagenow().'&action=view&id='.$_GET['id'].'&p='.($page-1).'">'.__( 'previous', WLS_TEXTDOMAIN ).'</a> &laquo;&nbsp;';
	}
	$navigation.= '<strong>'.sprintf( __( 'Page %d', WLS_TEXTDOMAIN ), $page ).'</strong>&nbsp;';
	if( $page*$entries_per_page < $entry_count ) {
		$navigation.= '&raquo; <a href="'.wls_get_pagenow().'&action=view&id='.$_GET['id'].'&p='.($page+1).'">'.__( 'next', WLS_TEXTDOMAIN ).'</a> &raquo;';
	}
	
	
	?>
	<div class="wrap">
		<h2><?php printf( __( 'Log category: %s', WLS_TEXTDOMAIN ), $log->log_name ); ?></h2>
		<p><?php echo $log->description; ?></p>
		<p><?php echo $navigation; ?></p>
		<?php
			
			wls_show_entry_table( $log_id, true, $from, $to, false );
		
		?>
		<p><?php echo $navigation; ?></p>
	</div>
	<?php
}


function wls_severity_to_string( $severity ) {
	switch( $severity ) {
	case 1:
		return 'debug';
	case 2:
		return 'notice';
	case 3:
		return 'warning';
	case 4:
		return 'error';
	case 5:
		return 'fatal';
	case 0:
	default:
		return 'none';
	}
}


function wls_string_to_severity( $s ) {
	if( $s == 'debug' )
		return 1;
	else if( $s == 'notice' )
		return 2;
	else if( $s == 'warning' )
		return 3;
	else if( $s == 'error' )
		return 4;
	else if( $s == 'fatal' )
		return 5;
	else 
		return 0;
}


function wls_category_to_style( $category ) {
	switch( $category ) {
	case 1:
		return '';
	case 2:
		return 'color:green;';
	case 3:
		return 'color:orange;font-weight:bold;';
	case 4:
		return 'color:red; font-weight:bold;';
	case 5:
		return 'font-weight:bold; color:white; background-color:red;';
	case 0:
	default:
		return '';
	}
}


?>
