<?php


/*****************************************************************************\
		ADMIN MENU
\*****************************************************************************/


add_action( 'network_admin_menu','wls_network_admin_menu' );


function wls_network_admin_menu() {
	$unseen = wls_get_unseen_entry_count();
	if( $unseen > 0 ) {
		$unseen = ' <span id="awaiting-mod" class="update-plugins count-'.$unseen.'"><span class="comment-count">'.$unseen.'</span></span>';
	} else {
		$unseen = '';
	}
	add_submenu_page( 'index.php', __( 'WLS system logs', WLS_TEXTDOMAIN ), __( 'System logs', WLS_TEXTDOMAIN ).$unseen,
		'manage_network_options', 'wls-superadmin-overview', 'wls_superadmin_overview_page' );
	add_submenu_page( 'settings.php', __( 'Wordpress Logging Service', WLS_TEXTDOMAIN ), __( 'Wordpress Logging Service', WLS_TEXTDOMAIN ),
		'manage_network_options', 'wls-settings', 'wls_settings_page' );
}


add_action( 'admin_menu', 'wls_admin_menu' );


function wls_admin_menu() {
	if( is_multisite() or !current_user_can( 'manage_options' ) ) {
		return;
	}
	$unseen = wls_get_unseen_entry_count();
	if( $unseen > 0 ) {
		$unseen = ' <span id="awaiting-mod" class="update-plugins count-'.$unseen.'"><span class="comment-count">'.$unseen.'</span></span>';
	} else {
		$unseen = '';
	}
	add_submenu_page( 'index.php', __( 'WLS system logs', WLS_TEXTDOMAIN ), __( 'System logs', WLS_TEXTDOMAIN ).$unseen,
		'manage_options', 'wls-superadmin-overview', 'wls_superadmin_overview_page' );
	add_submenu_page( 'options-general.php', __( 'Wordpress Logging Service', WLS_TEXTDOMAIN ), __( 'Wordpress Logging Service', WLS_TEXTDOMAIN ),
		'manage_options', 'wls-settings', 'wls_settings_page' );
}


/*****************************************************************************\
		OPTIONS
\*****************************************************************************/


function wls_settings_page() {
	
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'update-settings':
		wls_update_settings( $_POST['settings'] );
		wls_settings_page_default();
    	break;
    default:
    	wls_settings_page_default();
    }
}


function wls_settings_page_default() {
	
	$settings = wls_get_settings();
	extract( $settings );
	
	?>
	<div class="wrap">
		<h2><?php _e( 'Wordpress Logging Service', WLS_TEXTDOMAIN ); ?></h2>
        <form method="post">
            <input type="hidden" name="action" value="update-settings" />
            <table class="form-table">
                <tr valign="top">
                	<th>
                		<label for="def_severity_filter"><?php _e( 'Default severity filter on overview page', WLS_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<input type="text" name="settings[def_severity_filter]" value="<?php echo $def_severity_filter; ?>" />
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label for="wls_manager_id"><?php _e( 'WLS manager\'s ID', WLS_TEXTDOMAIN ); ?></label>
                	</th>
                	<td>
                		<input type="text" name="settings[wls_manager_id]" value="<?php echo $wls_manager_id; ?>" />
                	</td>
                </tr>
			</table>
			<p class="submit">
	            <input type="submit" value="<?php _e( 'Save', WLS_TEXTDOMAIN ); ?>" />    
	        </p>
		</form>
	</div>
	<?php

}

define( 'WLS_SETTINGS', 'wls_settings' );

function wls_get_settings() {
	$defaults = array(
		'def_severity_filter' => 2,
		'wls_manager_id' => 1
	);
	
	if( is_multisite() ) {
		$settings = get_site_option( WLS_SETTINGS, array() );
	} else {
		$settings = get_option( WLS_SETTINGS, array() );
	}
	
	return wp_parse_args( $settings, $defaults );
}


function wls_update_settings( $settings ) {
	if( is_multisite() ) {
		update_site_option( WLS_SETTINGS, $settings );
	} else {
		update_option( WLS_SETTINGS, $settings );
	}
}

?>
